> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Download an exported file

GET https://api.sigmacomputing.com/v2/query/{queryId}/download

After making a request to the [/v2/workbooks/{workbookId}/export](https://help.sigmacomputing.com/reference/export-workbook) or [/v2/reports/{reportId}/export](https://help.sigmacomputing.com/reference/export-report) endpoint, you can use this endpoint to download the exported file using the queryId returned in the response.

### Usage notes

- This endpoint is rate limited to 400 requests per minute.
- The export must be ready to download before you can download the results. The endpoint returns an error if the query is still processing or if the `queryId` is invalid or expired. Query results are typically available for a limited time, so make sure to download query results while they are available.
- Retrieve the **queryId** by making a request to the [/v2/workbooks/{workbookId}/export](https://help.sigmacomputing.com/reference/export-workbook) or [/v2/reports/{reportId}/export](https://help.sigmacomputing.com/reference/export-report) endpoint.
- Specify the file format when you make the export request. You cannot specify the file format when you download the file.

### Usage scenarios
- **Scheduled reporting**: Automate the downloading of reports generated on a scheduled basis.
- **Data analysis**: Retrieve large sets of data for local analysis in external tools not integrated directly with Sigma.

### Best practices
- Monitor the status of the export query before attempting a download to make sure it is ready. For a code example, see [Export to CSV with Date Range Parameters](https://help.sigmacomputing.com/recipes/workbook-export-to-csv-with-date-range-parameters).
- Handle errors gracefully in your application, providing users with clear messages regarding the status of their requested downloads.

Reference: https://help.sigmacomputing.com/reference/download-query

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/query/{queryId}/download:
    get:
      operationId: downloadQuery
      summary: Download an exported file
      description: >-
        After making a request to the
        [/v2/workbooks/{workbookId}/export](https://help.sigmacomputing.com/reference/export-workbook)
        or
        [/v2/reports/{reportId}/export](https://help.sigmacomputing.com/reference/export-report)
        endpoint, you can use this endpoint to download the exported file using
        the queryId returned in the response.


        ### Usage notes


        - This endpoint is rate limited to 400 requests per minute.

        - The export must be ready to download before you can download the
        results. The endpoint returns an error if the query is still processing
        or if the `queryId` is invalid or expired. Query results are typically
        available for a limited time, so make sure to download query results
        while they are available.

        - Retrieve the **queryId** by making a request to the
        [/v2/workbooks/{workbookId}/export](https://help.sigmacomputing.com/reference/export-workbook)
        or
        [/v2/reports/{reportId}/export](https://help.sigmacomputing.com/reference/export-report)
        endpoint.

        - Specify the file format when you make the export request. You cannot
        specify the file format when you download the file.


        ### Usage scenarios

        - **Scheduled reporting**: Automate the downloading of reports generated
        on a scheduled basis.

        - **Data analysis**: Retrieve large sets of data for local analysis in
        external tools not integrated directly with Sigma.


        ### Best practices

        - Monitor the status of the export query before attempting a download to
        make sure it is ready. For a code example, see [Export to CSV with Date
        Range
        Parameters](https://help.sigmacomputing.com/recipes/workbook-export-to-csv-with-date-range-parameters).

        - Handle errors gracefully in your application, providing users with
        clear messages regarding the status of their requested downloads.
      tags:
        - Query
      parameters:
        - name: queryId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/query_downloadQuery_Response_200'
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf0Status:
      type: string
      enum:
        - '200'
      description: Success
      title: >-
        V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf0Status
    V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf0Download:
      type: object
      properties:
        stream:
          description: Any type
        contentType:
          type: string
        filename:
          type: string
      required:
        - stream
        - contentType
        - filename
      description: Download results
      title: >-
        V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf0Download
    QueryDownloadQueryResponse2000:
      type: object
      properties:
        status:
          $ref: >-
            #/components/schemas/V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf0Status
          description: Success
        download:
          $ref: >-
            #/components/schemas/V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf0Download
          description: Download results
      required:
        - status
        - download
      title: QueryDownloadQueryResponse2000
    V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf1Status:
      type: string
      enum:
        - '204'
      description: Queued or running
      title: >-
        V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf1Status
    QueryDownloadQueryResponse2001:
      type: object
      properties:
        status:
          $ref: >-
            #/components/schemas/V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf1Status
          description: Queued or running
      required:
        - status
      title: QueryDownloadQueryResponse2001
    V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf2Status:
      type: string
      enum:
        - '500'
      description: Internal server error
      title: >-
        V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf2Status
    QueryDownloadQueryResponse2002:
      type: object
      properties:
        status:
          $ref: >-
            #/components/schemas/V2QueryQueryIdDownloadGetResponsesContentApplicationJsonSchemaOneOf2Status
          description: Internal server error
        message:
          type: string
          description: Error message
      required:
        - status
        - message
      title: QueryDownloadQueryResponse2002
    query_downloadQuery_Response_200:
      oneOf:
        - $ref: '#/components/schemas/QueryDownloadQueryResponse2000'
        - $ref: '#/components/schemas/QueryDownloadQueryResponse2001'
        - $ref: '#/components/schemas/QueryDownloadQueryResponse2002'
      title: query_downloadQuery_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples

### Success



**Response**

```json
{
  "download": {
    "contentType": "application/octet-stream",
    "filename": "string",
    "stream": "[Object NodeJS.ReadableStream]"
  },
  "status": 200
}
```

**SDK Code**

```python Success
import requests

url = "https://api.sigmacomputing.com/v2/query/queryId/download"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Success
const url = 'https://api.sigmacomputing.com/v2/query/queryId/download';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Success
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/query/queryId/download"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Success
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/query/queryId/download")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java Success
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/query/queryId/download")
  .header("Authorization", "<token>.")
  .asString();
```

```php Success
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/query/queryId/download', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp Success
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/query/queryId/download");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift Success
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/query/queryId/download")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Running



**Response**

```json
{
  "status": 204
}
```

**SDK Code**

```python Running
import requests

url = "https://api.sigmacomputing.com/v2/query/queryId/download"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Running
const url = 'https://api.sigmacomputing.com/v2/query/queryId/download';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Running
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/query/queryId/download"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Running
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/query/queryId/download")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java Running
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/query/queryId/download")
  .header("Authorization", "<token>.")
  .asString();
```

```php Running
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/query/queryId/download', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp Running
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/query/queryId/download");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift Running
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/query/queryId/download")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```